
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>写出高效率的正则表达式技巧总结_正则表达式 / iVAN</title>

    <meta name="description" content="写出高效率的正则表达式技巧总结_正则表达式 如果纯粹是为了挑战自己的正则水平,用来实现一些特效(例如使用正则表达式计算质数.解线性方程),效率不是问题:如果所写的正则表达式只是为了满足一两次.几十次的运行,优化与否区别也不太大.但是,如果所写的正则表达式会百万次.千万次地运行,效率就是很大的问题了.  为行文方便,先定义两个概念.误匹配:指正则表达式所匹配的内容范围超出了所需要范围,有些文本明明不符合要求,但是被所写的正则式&quot;击中了&quot;.例如,如果使用\d{11}来匹配11位的手机号,\d{11}不单能匹配正确的手机号, ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">写出高效率的正则表达式技巧总结_正则表达式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>如果纯粹是为了挑战自己的正则水平，用来实现一些特效（例如使用正则表达式计算质数、解线性方程），效率不是问题；如果所写的正则表达式只是为了满足一两次、几十次的运行，优化与否区别也不太大。但是，如果所写的正则表达式会百万次、千万次地运行，效率就是很大的问题了。</p>
<p> 为行文方便，先定义两个概念。<br /><strong>误匹配：</strong>指正则表达式所匹配的内容范围超出了所需要范围，有些文本明明不符合要求，但是被所写的正则式“击中了”。例如，如果使用\d{11}来匹配11位的手机号，\d{11}不单能匹配正确的手机号，它还会匹配98765432100这样的明显不是手机号的字符串。我们把这样的匹配称之为误匹配。<br /><strong>漏匹配：</strong>指正则表达式所匹配的内容所规定的范围太狭窄，有些文本确实是所需要的，但是所写的正则没有将这种情况囊括在内。例如，使用\d{18}来匹配18位的身份证号码，就会漏掉结尾是字母X的情况。<br />
写出一条正则表达式，既可能只出现误匹配（条件写得极宽松，其范围大于目标文本），也可能只出现漏匹配（只描述了目标文本中多种情况种的一种），还可能既有误匹配又有漏匹配。例如，使用\w+\.com来匹配.com结尾的域名，既会误匹配abc_.com这样的字串（合法的域名中不含下划线，\w包含了下划线这种情况），又会漏掉ab-c.com这样的域名（合法域名中可以含中划线，但是\w不匹配中划线）。<br />
精准的正则表达式意味着既无误匹配且无漏匹配。当然，现实中存在这样的情况：只能看到有限数量的文本，根据这些文本写规则，但是这些规则将会用到海量的文本中。这种情况下，尽可能地（如果不是完全地）消除误匹配以及漏匹配，并提升运行效率，就是我们的目标。本文所提出的经验，主要是针对这种情况。<br /><strong>掌握语法细节。</strong>正则表达式在各种语言中，其语法大致相同，细节各有千秋。明确所使用语言的正则的语法的细节，是写出正确、高效正则表达式的基础。例如，perl中与\w等效的匹配范围是[a-zA-Z0-9_]；perl正则式不支持肯定逆序环视中使用可变的重复（variable repetition inside lookbehind，例如(?&lt;=.*)abc），但是.Net语法是支持这一特性的；又如，JavaScript连逆序环视（Lookbehind,如(?&lt;=ab)c）都不支持，而perl和python是支持的。《精通正则表达式》第3章《正则表达式的特性和流派概览》明确地列出了各大派系正则的异同，这篇文章也简要地列出了几种常用语言、工具中正则的比较。对于具体使用者而言，至少应该详细了解正在使用的那种工作语言里正则的语法细节。<br /><strong>先粗后精，先加后减。</strong>使用正则表达式语法对于目标文本进行描述和界定，可以像画素描一样，先大致勾勒出框架，再逐步在局步实现细节。仍举刚才的手机号的例子，先界定\d{11}，总不会错；再细化为1[358]\d{9}，就向前迈了一大步（至于第二位是不是3、5、8，这里无意深究，只举这样一个例子，说明逐步细化的过程）。这样做的目的是先消除漏匹配（刚开始先尽可能多地匹配，做加法），然后再一点一点地消除误匹配（做减法）。这样有先有后，在考虑时才不易出错，从而向“不误不漏”这个目标迈进。<br /><strong>留有余地。</strong>所能看到的文本sample是有限的，而待匹配检验的文本是海量的，暂时不可见的。对于这样的情况，在写正则表达式时要跳出所能见到的文本的圈子，开拓思路，作出“战略性前瞻”。例如，经常收到这样的垃圾短信：“发*票”、“发#漂”。如果要写规则屏蔽这样烦人的垃圾短信，不但要能写出可以匹配当前文本的正则表达式 发[*#](?:票|漂)，还要能够想到 发.(?:票|漂|飘)之类可能出现的“变种”。这在具体的领域或许会有针对性的规则，不多言。这样做的目的是消除漏匹配，延长正则表达式的生命周期。<br /><strong>明确。</strong>具体说来，就是谨慎用点号这样的元字符，尽可能不用星号和加号这样的任意量词。只要能确定范围的，例如\w，就不要用点号；只要能够预测重复次数的，就不要用任意量词。例如，写析取twitter消息的脚本，假设一条消息的xml正文部分结构是&lt;span class=”msg”&gt;…&lt;/span&gt;且正文中无尖括号，那么&lt;span class=”msg”&gt;[^&lt;]{1,480}&lt;/span&gt;这种写法的思路要好于&lt;span class=”msg”&gt;.*&lt;/span&gt;，原因有二：一是使用[^&lt;]，它保证了文本的范围不会超出下一个小于号所在的位置；二是明确长度范围，{1,480}，其依据是一条twitter消息大致能的字符长度范围。当然，480这个长度是否正确还可推敲，但是这种思路是值得借鉴的。说得狠一点，“滥用点号、星号和加号是不环保、不负责任的做法”。<br /><strong>不要让稻草压死骆驼。</strong>每使用一个普通括号()而不是非捕获型括号(?:…)，就会保留一部分内存等着你再次访问。这样的正则表达式、无限次地运行次数，无异于一根根稻草的堆加，终于能将骆驼压死。养成合理使用(?:…)括号的习惯。<br /><strong>宁简勿繁。</strong>将一条复杂的正则表达式拆分为两条或多条简单的正则表达式，编程难度会降低，运行效率会提升。例如用来消除行首和行尾空白字符的正则表达式s/^\s+|\s+$//g;，其运行效率理论上要低于s/^\s+//g; s/\s+$//g; 。这个例子出自《精通正则表达式》第五章，书中对它的评论是“它几乎总是最快的，而且显然最容易理解”。既快又容易理解，何乐而不为？工作中我们还有其它的理由要将C==(A|B)这样的正则表达式拆为A和B两条表达式分别执行。例如，虽然A和B这两种情况只要有一种能够击中所需要的文本模式就会成功匹配，但是如果只要有一条子表达式（例如A）会产生误匹配，那么不论其它的子表达式（例如B）效率如何之高，范围如何精准，C的总体精准度也会因A而受到影响。<br /><strong>巧妙定位。</strong>有时候，我们需要匹配的the，是作为单词的the（两边有空格），而不是作为单词一部分的t-h-e的有序排列（例如together中的the）。在适当的时候用上^，$，\b等等定位锚点，能有效提升找到成功匹配、淘汰不成功匹配的效率。</p>
<p>以上就是总结了几条提升正则表达式运行效率的经验（工作中学到的，看书学来的，自己的体会），整理在这里。如果您有其它的经验而这里没有提及，欢迎讨论。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-05 06:44:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>写出高效率的正则表达式技巧总结_正则表达式的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bojEBEz.html" rel="bookmark">写出高效率的正则表达式技巧总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果纯粹是为了挑战自己的正则水平,用来实现一些特效(例如使用正则表达式计算质数.解线性方程),效率不是问题:如果所写的正则表达式只是为了满足一两次.几十次的运行,优化与否区别也不太大.但是,如果所写的正则表达式会百万次.千万次地运行,效率就是很大的问题了. 为行文方便,先定义两个概念. 误匹配:指正则表达式所匹配的内容范围超出了所需要范围,有些文本明明不符合要求,但是被所写的正则式&quot;击中了&quot;.例如,如果使用\d{11}来匹配11位的手机号,\d{11}不单能匹配正确的手机号,它还会匹配			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0BqRjz.html" rel="bookmark">Java正则表达式过滤出字母、数字和中文&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Java中过滤出字母.数字和中文的正则表达式 (1)过滤出字母的正则表达式       [^(A-Za-z)] (2) 过滤出 数字 的正则表达式    [^(0-9)] (3) 过滤出 中文 的正则表达式        [^(\\u4e00-\\u9fa5)] (4) 过滤出字母.数字和中文的正则表达式        [^(a-zA-Z0-9\\u4e00-\\u9fa5)] 2.实例源码 ** * @Title:FilterStr.java * @Package:com.you.dao			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYN5e6p.html" rel="bookmark">正则表达式 应用四则&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以前就想总结一下,一直没有时间,今天看见了一篇好文,特此贡献出来,尽情享受正则的强大功能吧!! 以下为正文内容: ------------------------------------------------------------ 正则表达式(Regular Expression)为字符串模式匹配提供了一种高效.方便的方法.几乎所有高级语言都提供了对正则表达式的支持,或者提供了现成的代码库供调用.本文以ASP环境中常见的处理任务为例,介绍正则表达式的应用技巧.     一.检验密码和邮件地址			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0NRw8z.html" rel="bookmark">Linux 正则表达式详解&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.linux文本查找命令 在说linux正规表达式之前,还介绍下linux中查找文本文件常用的三个命令: 1.grep : 最早的文本匹配程序,使用POSIX定义的基本正则表达式(BRE)来匹配文本. 2.egrep : 扩展式grep,其使用扩展式正规表达式(ERE)来匹配文本. 3.fgrep : 快速grep,这个版本匹配固定字符串而非正则表达式.并且是唯一可以并行匹配多个字符串的版本. 如下简单的介绍grep命令: 语法格式: grep [options ...] pattern-sp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr2Xn6M.html" rel="bookmark">比较全面的C 、Java、JavaScript中的正则表达式详解&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是正则表达式? 正则表达式(Regular Expression) 就是用某种模式去匹配一类字符串的公式.如你要在一篇文章中查找第一个字是&quot;罗&quot;最后一个字是&quot;浩&quot;的三个字的姓名,即&quot;罗 * 浩&quot;:那么&quot;罗 * 浩&quot;就是公式,也称作 模式(Pattern) ,这篇文章就是 要匹配的串( 或叫文本 text) .再如,你要检查输入的一个字符串是否是 126 邮箱的格式,你得制定一个规则去查检,这种规则就是正则表达式. 从入门开			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV70Kmb.html" rel="bookmark">php的正则表达式完全手册&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: (?:pattern) 匹配 pattern 但不获取匹配结果,也就是说这是一个非获取匹配,不进行存储供以后使用.这在使用 &quot;或&quot; 字符 (|) 来组合一个模式的各个部分是很有用.例如, 'industr(?:y|ies) 就是一个比 'industry|industries' 更简略的表达式. (?=pattern) 正向预查,在任何匹配 pattern 的字符串开始处匹配查找字符串.这是一个非获取匹配,也就是说,该匹配不需要获取供以后使用.例如,'Window			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAkAOKz.html" rel="bookmark">日常收集整理php正则表达式&lpar;超常用&rpar;&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以下是关于小编给大家日常收集整理php正则表达式,具体内容请看下文详解吧 $str = preg_replace(&quot;/(&lt;a.*?&gt;)(.*?)(&lt;\/a&gt;)/&quot;, '\1&lt;span&gt;\2&lt;/span&gt;\3', $str); 其中用了三个子模式(每个圆括号中内容为一个子模式),第一个是链接开始标签,第二个是链接文本,第三个是&lt;/a&gt; 然后第二个参数中\1.\2.\3就表示这三个部分,要替换成什么样子还不简单? 获取页面中的所有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmVKa1z.html" rel="bookmark">最常用的PHP正则表达式收集整理&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP代码 $str = preg_replace(&quot;/(&lt;a.*?&gt;)(.*?)(&lt;\/a&gt;)/&quot;, '\1&lt;span class=&quot;link&quot;&gt;\2&lt;/span&gt;\3', $str); 其中用了三个子模式(每个圆括号中内容为一个子模式),第一个是链接开始标签,第二个是链接文本,第三个是&lt;/a&gt; 然后第二个参数中\1.\2.\3就表示这三个部分,要替换成什么样子还不简单? 获取页面中的所有链接地址的PHP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnnWROp.html" rel="bookmark">MySQL中REGEXP正则表达式使用大全&lowbar;正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以前我要查找数据都是使用like后来发现mysql中也有正则表达式了并且感觉性能要好于like,下面我来给大家分享一下mysql REGEXP正则表达式使用详解,希望此方法对大家有帮助. MySQL采用Henry Spencer的正则表达式实施,其目标是符合POSIX 1003.2.请参见附录C:感谢.MySQL采用了扩展的版本,以支持在SQL语句中与REGEXP操作符一起使用的模式匹配操作.请参见3.3.4.7节,&quot;模式匹配&quot;. 在本附录中,归纳了在MySQL中可用于REGEXP操作			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7k8Xz.html" rel="bookmark" class="title">升级win8系统后发现&OpenCurlyDoubleQuote;我的电脑&rdquo;图标不见的解决方法</a>
					<div>
						  1.首先需要先回到桌面,然后右键单机鼠标; 2.点击&quot;个性化(R)&quot;,进入当前页面; 3.点击&quot;更换桌面图标&quot;,进入&quot;桌面图标设置&quot;;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZRNOz.html" rel="bookmark" class="title">AJAX实现基于WEB的文件上传的进度控制</a>
					<div>
						ajax|web|控制|上传 1. 引言  2. 实现代码  2.1. 服务器端代码  2.1.1. 文件上传状态类(FileUploadStatus)  2.1.2. 文件上传状态侦听类(FileU ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7yynb.html" rel="bookmark" class="title">BDD中的常用工具</a>
					<div>
						什么是BDD? BDD在wikipedia上定义如下: BDD是第二代的.由外及内的.基于拉(pull)的.多方利益相关者的(stakeholder).多种可扩展的.高自动化的敏捷方法.它描述了一个交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAamDeM.html" rel="bookmark" class="title">可牛影像修调人物身高 秀出绝配情侣</a>
					<div>
						近日,关于湖南电视台自制青春偶像剧&lt;一起又看流星雨&gt;的质疑.讨论铺天盖地,该剧的两位主演张翰.郑爽也收到广泛的关注,但在翻看宣传海报时,牛牛发现这对荧幕中的黄金情侣在身高搭配上却略显遗憾. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jQN4b.html" rel="bookmark" class="title">Fireworks CS5工具面板</a>
					<div>
						  &quot; 工具&quot; 面板被编排为六个类别:选择.位图.矢量.Web.颜色和视图.当您选择一种工具时, &quot; 属性&quot; 检查器将显示工具选项. 将工具选项显示在&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZ776z.html" rel="bookmark" class="title">WPS表格快速隐藏不使用的区域方法</a>
					<div>
						  在自动化办公中,如果希望在WPS表格中只显示指定的部分区域,其余部分设置为隐藏,则需要多次使用行隐藏和列隐藏命令.作为办公高手,可以用VBA代码将选中的连续区域以外的区域一次性全部隐藏. 第一步, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEW64Pp.html" rel="bookmark" class="title">注册表备份还原方法</a>
					<div>
						XP中手动备份注册表的步骤 单击&quot;开始&quot;,单击&quot;运行&quot;,键入 %SystemRoot%system32restorerstrui.exe,然后单击&quot;确 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8Zgmp.html" rel="bookmark" class="title">win7系统图片不显示预览图怎么办</a>
					<div>
						win7上图片只显示图标,不显示缩略图;不管是调节小图.中图还是大图或者其他均不显示;而且这种情况下使用截图工具截下来的图片都不自动带上扩展名,怎么办呢? 解决方案: 打开计算机-&gt;组织-&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e6LLb.html" rel="bookmark" class="title">macbookair配置怎么样</a>
					<div>
						  苹果可能将很快推出配备视网膜显示屏的新一代macbookair笔记本,但是近些年来没有任何迹象表明将会推出纯黑色的笔记本.其实对于许多粉丝们来说,依然对之前苹果的黑色版MacBook念念不忘.曾经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywVvZz.html" rel="bookmark" class="title">现场直击：中国人的数据库分支AliSQL开放源代码下载 功能新增秒杀场景优化、TokuDB</a>
					<div>
						Mysql之父和Alisql 之父的碰撞 北京时间10月14日消息,阿里云研究员褚霸在云栖大会&lt;开发者技术峰会--开源技术专场&gt;分论坛上,和MySQL之父.Maria DB CTO Mic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQwrVz.html" rel="bookmark" class="title">【阿里在线技术峰会】蒋晓伟：Blink计算引擎</a>
					<div>
						本文根据阿里资深搜索专家蒋晓伟在首届阿里巴巴在线峰会上的分享整理而成. 此次分享的重点是Blink计算引擎,它是阿里巴巴搜索的流计算和批处理引擎.相比于Flink,在上层,Blink具有批和流一体化的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEWxdz.html" rel="bookmark" class="title">华硕电脑的BIOS中power off energy saving是设置关闭好还是开启好？</a>
					<div>
						问题描述 华硕电脑的BIOS中power off energy saving是设置关闭好还是开启好? 我的华硕点脑中BIOS界面上的power off energy saving默认是开启的,但是有人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeW3Wb.html" rel="bookmark" class="title">Spring MVC数据校验与国际化</a>
					<div>
						1. JSR-303 JSR-303 是JAVA EE 6 中的一项子规范,叫做Bean Validation,官方参考实现是Hibernate Validator. 此实现与Hibernate OR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXvaOz.html" rel="bookmark" class="title">asp上传图片-asp网站后台上传图片没反应</a>
					<div>
						问题描述 asp网站后台上传图片没反应 新手做了一个asp的企业网站,后台有个上传图片并显示的功能,点击上传图片一直没反应,有时候可以上传,有时候就上传不了,跪求哪位高手可以指导指导,QQ:23012 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z2Y6z.html" rel="bookmark" class="title">一个android上的web view的问题，ajax能解决这个问题么？</a>
					<div>
						问题描述 一个android上的web view的问题,ajax能解决这个问题么? android 的webview装入一个动态网页,网页列表比较大,所以启动的时候要卡住好一会儿.如果已经得到了htm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYmjGp.html" rel="bookmark" class="title">MySQL 管理&lowbar;Mysql</a>
					<div>
						对于内容驱动的网站,设计好坏的关键是关系型数据库.在这个教程中,我们已经使用了MySQL关系型数据库管理系统(RDBMS)建立了我们的数据库.对于网站的开发者来说,MySQL是一个较受欢迎的选择,这不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40jdrz.html" rel="bookmark" class="title">汽车巨头福特的大数据之路</a>
					<div>
						&quot;数据将让你自由&quot;这是首席执行官艾伦·穆拉利(Alan Mully)与2007就任福特汽车公司CEO后常说的一句话.当时,福特汽车公司如同一首正在下沉的巨轮,亏损连连,找不到方向. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1NdOz.html" rel="bookmark" class="title">在一个mvc项目中运行单元测试竟然报错，求助！</a>
					<div>
						问题描述 我创建了一个mvc3的项目,该项目使用了单元测试.但是我vs2010中按照测试---&gt;运行----&gt;解决方案中的所有测试时vs2010弹出一个对话框报告说调用的目标发生异常.我在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKN83b.html" rel="bookmark" class="title">高人求救啊</a>
					<div>
						问题描述 asp.net本地项目远程连接oracle数据库总是连接超时但PLSQL工具可以远程连接上项目没有问题以前可以连接上没问题就这段时间不能个人以为可能是网速原因这2天换了个路由器掉包严重网速很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7x6G4b.html" rel="bookmark" class="title">询问 java 操作 IBM mQ时控制端打印的异常信息屏蔽方法</a>
					<div>
						问题描述 Java操作IBMMQ时,比如get()消息时,队列中如果没有消息,会在控制端报异常,请问有什么办法可以屏蔽之,try{}catch(){}不管用					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPk2w8M.html" rel="bookmark" class="title">中科院叫卖联想控股 分析师称早已暗定接盘者</a>
					<div>
						本报实习记者 翟磊 北京报道 几乎是联想集团发布第二季度财报的同时,其母公司联想控股又遭遇了大股东中科院的大幅减持, 这不免让人将两者联系到了一起.据本报记者了解,7日,中科院在北京产权交易所挂牌出售 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZoROp.html" rel="bookmark" class="title">wince平台 嵌入式编程开发 无法在coredll&period;dll中找到FindWinow的入口点</a>
					<div>
						问题描述 用vs2008搭建了wince平台进行手持终端开发,在WindowsCE5.0Emulator部署调试的时候出现&quot;MissingManifestResourceException& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0aN4p.html" rel="bookmark" class="title">c&num; asp net-有没有高手知道正则表达式里面&OpenCurlyDoubleQuote;&lbrack;&Hat;&lbrack;&rsqb;&quest;&rdquo;什么情况下会匹配一次？</a>
					<div>
						问题描述 有没有高手知道正则表达式里面&quot;[^[]?&quot;什么情况下会匹配一次? sql.SqlClause=&quot;&quot;alter table [Account] add  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye5N4M.html" rel="bookmark" class="title">案例：神龙汽车业务数据中心虚拟化整合</a>
					<div>
						文章讲的是案例:神龙汽车业务数据中心虚拟化整合,全球虚拟化和云基础架构领导厂商VMware公司(NYSE 交易代码:VMW)宣布,通过部署VMware数据中心虚拟化解决方案,神龙汽车成功地实现了服务器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNQR9p.html" rel="bookmark" class="title">android判断软件是否第一次运行的方法&lowbar;Android</a>
					<div>
						本文实例讲述了android判断软件是否第一次运行的方法.分享给大家供大家参考.具体如下: SharedPreferences sharedPreferences = this.getSharedPr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YNjWp.html" rel="bookmark" class="title">北风网权威解答：如何选择Java、&period;NET、C&sol;C&plus;&plus;</a>
					<div>
						有相当多的计算机初学者,都喜欢关注哪一个专业更好,深怕学了之后会出现厌学.误学等方面的问题,为此,北风网的IT培训学校专家则表示:在软件行业,每个专业都一样很热门,主要是看个人对什么更感兴趣一点,特别 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baq0jnb.html" rel="bookmark" class="title">《编写高质量Python代码的59个有效方法》&mdash;&mdash;第8条：不要使用含有两个以上表达式的列表推导</a>
					<div>
						第8条:不要使用含有两个以上表达式的列表推导除了基本的用法(参见本书第7条)之外,列表推导也支持多重循环.例如,要把矩阵(也就是包含列表的列表,即二维列表)简化成一维列表,使原来的每个单元格都成为新列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0jQWM.html" rel="bookmark" class="title">php验证码实现代码（3种）&lowbar;php实例</a>
					<div>
						验证码在表单实现越来越多了,但是用js的写的验证码,总觉得不方便,所以学习了下php实现的验证码. 好吧,其实是没有事情干,但是又不想浪费时间,所以学习了下php实现验证码.正所谓,技多不压身.而且, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJeYq4p.html" rel="bookmark" class="title">OTT整顿：&OpenCurlyDoubleQuote;三网融合&rdquo; 孰强孰弱</a>
					<div>
						&quot;史上最严&quot;的互联网电视集成播控整顿也波及到了电信运营商. 据&lt;第一财经日报&gt;记者了解,广电总局最近密集约谈了7家互联网电视牌照方,根据181号文点名批评所有牌照方频频 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgP578p.html" rel="bookmark" class="title">情人节礼物 白色版Galaxy Nexus真机图赏</a>
					<div>
						据国外最新报道显示,之前多次曝光的三星白色靓机Galaxy Nexus日前已经于新加坡和英国上市,给情人节的礼物增添了新的选择.遗憾的是该机还未在国内上市,不过国外媒体http://www.aliyu ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
